defmodule PortingTools.Mappings do
  use GenServer, restart: :transient
  require Logger

  def start_link(_) do
    GenServer.start_link(__MODULE__, nil, name: __MODULE__)
  end

  def init(_init_arg) do
    Logger.info("Initilizing mappings server @ #{__MODULE__}")
    {:ok, nil}
  end

  def map(str) do
    GenServer.call(__MODULE__, {:map, str})
  end

  def handle_call({:map, str}, _from, state) do
    Logger.info("Got map request to map #{str}")
    {:reply, PortingTools.Mappings.Agent.map(str), state}
  end
end
